
// 对Date的扩展，将 Date 转化为指定格式的String
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)
// 例子：
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18
Date.prototype.Format = function(fmt)
{ //author: meizz
    var o = {
        "M+" : this.getMonth()+1,                 //月份
        "d+" : this.getDate(),                    //日
        "h+" : this.getHours(),                   //小时
        "m+" : this.getMinutes(),                 //分
        "s+" : this.getSeconds(),                 //秒
        "q+" : Math.floor((this.getMonth()+3)/3), //季度
        "S"  : this.getMilliseconds()             //毫秒
    };
    if(/(y+)/.test(fmt))
        fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
    for(var k in o)
        if(new RegExp("("+ k +")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
    return fmt;   
}


var isAndroid = 1;
//var agent = window.tyagent;
var storage = window.localStorage;
//if (agent == undefined || agent == null){
//	isAndroid = 0;
//	agent = window.webkit.messageHandlers.tyagent;
//}
//提交数据给native
function postMessage(json){
	return json;
}
function buildParam(cmd,data){
	var json = {};
	json.cmd = cmd;
	json.extra = data;
	return json;
}
//跳转页面
function gotoPage(page,data){
    if (data == null || data == undefined){
        var extra = {};
        extra.page = page;
        postMessage(buildParam(1,extra));
    }
    else{
        data.page = page;
        postMessage(buildParam(1,data));
    }
}
//请求数据
function requestData(action,data){
    if (data == null || data == undefined){
        var extra = {};
        extra.action = action;
        postMessage(buildParam(2,extra));
    }else{
        data.action = action;
        postMessage(buildParam(2,data));
    }
}
//去掉json字符串中的特殊字符
function formatJson(jsonStr){
//    txtValue = txtValue.replace(/\/\*((\n|\r|.)*?)\*\//mg, "");	//去掉多行注释/*..*/
//    txtValue = txtValue.replace(/(\s+)\/\/(.*)\n/g,"");	//去掉单行注释//(前面有空格的注释)
//    txtValue = txtValue.replace(/;\/\/(.*)\n/g,";");//去掉单行注释//(前面是分号的注释)
//    txtValue = txtValue.replace(/\/\/[^"][^']\n/g,""); //去掉单行注释//(//后面只有一个'或一个"的不替换)
    var tmpStr = jsonStr;
    tmpStr = tmpStr.replace(/[\r]/g,"");		//替换换行
    tmpStr = tmpStr.replace(/[\n]/g,"");		//替换回车
    return tmpStr;
}
function parseData(jsonStr){
    if (jsonStr==undefined)
        return eval("("+formatJson("[]")+")");
	return eval("("+formatJson(jsonStr)+")");
}
//保存数据到localstorage
function saveData(key,value){
    storage.removeItem(key);
    storage.setItem(key,value);
}
//获取本地localstorage保存的数据
function loadData(key){
    return storage.getItem(key);
}
//保存json对象
function saveObject(key,value){
    storage.removeItem(key);
    storage.setItem(key,JSON.stringify(value));
}
//获取本地json对象
function loadObject(key){
    return JSON.parse(formatJson(storage.getItem(key)));
}
//判断日期是否相等srcDate为Date对象
function isEqualDay(srcDate,targetDate){
    return (srcDate.getFullYear()== targetDate.getFullYear()) && (srcDate.getMonth() == targetDate.getMonth()) && (srcDate.getDate() == targetDate.getDate());
}
//是否与今天相等
function isToday(srcDate){
    return isEqualDay(srcDate,new Date());
}
function uuid() {
    var s = [];
    var hexDigits = "0123456789abcdef";
    for (var i = 0; i < 36; i++) {
        s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
    }
    s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
    s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
    s[8] = s[13] = s[18] = s[23] = "-";
    
    var uuid = s.join("");
    return uuid;
}
