// 封装上拉加载，下拉刷新
var $ = mui,
        doc = document,
        aPullRefresh = {
            url: '', // 接口地址
            opt: {}, // 接口参数
            list: [], // 初始化数据缓存
            layer: '', // 加载内容div
            pullRefreshLayer: '' // 刷新div
        };

$.init({
    pullRefresh: {
        container: '#pullrefresh',
        down: {
            style:'circle',//必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
            color:'#2BD009', //可选，默认“#2BD009” 下拉刷新控件颜色
            height:'50px',//可选,默认50px.下拉刷新控件的高度,
            range:'100px', //可选 默认100px,控件可下拉拖拽的范围
            offset:'0px',
            callback: pulldownRefresh
        },
        up: {
            contentrefresh: '正在加载...',
            contentnomore: '没有更多数据了',
            callback: pullupRefresh
        }
    }
});

// /**
//  * 下拉刷新具体业务实现
//  */
function pulldownRefresh() {
    plus.nativeUI.showWaiting('加载中...');
    // 下拉刷新，重新请求第一页数据
    aPullRefresh.opt.current = 0;
    // 结束下拉动画
    aPullRefresh.pullRefreshLayer.pullRefresh().endPulldownToRefresh();
    // 重置上拉刷新
    aPullRefresh.pullRefreshLayer.pullRefresh().refresh(true);
    pullupRefresh();
}

// 待用方法
// 禁用上拉刷新
// mui('#pullup-container').pullRefresh().disablePullupToRefresh();
// 启用上拉刷新
// mui('#pullup-container').pullRefresh().enablePullupToRefresh();
/**
 * 上拉加载具体业务实现
 */
function pullupRefresh() {
    plus.nativeUI.closeWaiting();
    // 添加上拉次数
    aPullRefresh.opt.current++;
    // 请求数据
    $.ajax(httpNetwork + aPullRefresh.url,{
        data: aPullRefresh.opt,
        dataType:'json',
        type: 'get',
        timeout:10000,
        success: function(res){
            if (res.success && res.obj.records) {
                aPullRefresh.pullRefreshLayer.pullRefresh().endPullupToRefresh((res.obj.pages <= aPullRefresh.opt.current));
                // 修改图片
                res.obj.records.forEach((element, index) => {
                    if (element.pic && element.pic.indexOf('http') == -1) {
                        var img = element.pic.substring(1, element.pic.length - 1)
                        res.obj.records[index].pic = http + '/upload/' + img;
                    }
                });
                var html = template('pullList', res.obj.records);
                if (aPullRefresh.opt.current === 1) {
                    aPullRefresh.layer.innerHTML = html;
                } else {
                    // 如果当前页等于总页数，则无下拉数据
                    aPullRefresh.layer.innerHTML += html;
                }
                // 添加事件 点击详情my-order-doctorInfo.html
                $('#pullrefresh').on('tap', '.clickInfo', function () {
                    // var doctorInfo = plus.webview.getWebviewById('my-order-doctorInfo.html');
                    // plus.webview.close(doctorInfo);
                    mui.openWindow({
                        url: "/page/my/order/doctorInfo.html",
                        id: "my-order-doctorInfo.html",
                        extras:{
                            orderID: this.getAttribute('data-index'),
                            fromMoney: false
                        }
                    })
                });
                // 添加事件 去支付data-endTime
                $('.Box').on('tap', '.BoxFooterGoOrder', function () {
                    var reportInfo = {
                        id: this.getAttribute('data-index'),
                        endTime: this.getAttribute('data-endTime'),
                        doctorName: this.getAttribute('data-doctorName'),
                        payAmount: this.getAttribute('data-payAmount')
                    };
                    mui.openWindow({
                        url: "/page/patient_info/imageText/orderPay.html",
                        id: "imageText-orderPay.html",
                        extras:{
                            reportInfo: reportInfo
                        }
                    })
                });
                // 添加事件 取消订单
                $('.Box').on('tap', '.BoxFooterCancelOrder', function () {
                    console.log(this.getAttribute('data-index'))
                    var opt = {
                        id: this.getAttribute('data-index')
                    };
                    var btnArray = ['否', '是'];
                    mui.confirm('确认取消订单？', '提示', btnArray, function(e) {
                        if (e.index == 1) {
                            plus.nativeUI.showWaiting('加载中...');
                            myHttp('/inqorder/inqOrderCancel', opt, 'POST', function (result) {
                                    if (result.success) {
                                        $.toast("取消成功");
                                        pulldownRefresh();
                                    } else {
                                        console.log('问诊订单取消失败')
                                    }
                                    plus.nativeUI.closeWaiting();
                            });
                        } else {
                        }
                    });
                });
                // 添加事件 去退款
                $('.Box').on('tap', '.Refundable', function () {
                    console.log(this.getAttribute('data-index'))
                    var opt = {
                        id: this.getAttribute('data-index')
                    };
                    var btnArray = ['否', '是'];
                    mui.confirm('是否确认申请退款？', '提示', btnArray, function(e) {
                        if (e.index == 1) {
                            plus.nativeUI.showWaiting('加载中...');
                            myHttp('/inqorder/applyRefund', opt, 'POST', function (result) {
                                    if (result.success) {
                                        $.toast("申请成功");
                                        pulldownRefresh();
                                    } else {
                                        console.log('申请退款失败')
                                    }
                                    plus.nativeUI.closeWaiting();
                            });
                        } else {
                        }
                    });
                });
                // 添加事件 去资讯页面
                $('.Box').on('tap', '.goQuestion', function () {
                    mui.openWindow({
                        url: "/page/chat/imChat.html",
                        id: "page-chat-imChat.html",
                        extras:{
                            otherSide: this.getAttribute('data-docPhone') + 'doctor',
							orderId: this.getAttribute('data-index')
                        }
                    })
                });
            } else {
                $.toast("未获取到数据");
            }
        },
        error:function(){
            $.toast("请检查网络");
        }
    })
}