// 公用工具
var tool = {};
var doc = document;
// 页面跳转无等待框
tool.openWindow = function (id, url) {
    doc.getElementById(id).addEventListener('tap', function () {
        mui.openWindow({
            id: id,
            url: url,
            waiting: {
                autoShow: false
            }
        });
    });
};

// 点击清除全部页面
tool.clearWebview = function () {
    var all = plus.webview.all();
    var current = plus.webview.currentWebview().id;
    for (var i = 0, len = all.length; i < len; i++) {
        if (all[i].id !== current) {
            all[i].close();
        }
    }
};

// 判断是否登录 没有直接返回
tool.isLogin = function (callback, beforePage) {
    if (!plus.storage.getItem('user')) {
        mui.openWindow({
            url: "/login.html",
            id: "login.html",
            extras: {
                callbackUrl: beforePage,
            }
        });
        return;
    } else {
        callback();
    }
}

// 支付
tool.pay = function (url, test, callBack) {
    // 获取支付通道
    var pays = {};
    var id = test;
    id == 'alipay' ? id = 'alipay' : id = 'wxpay';
    console.log('id：' + id);
    plus.payment.getChannels(function (channels) {
        for (var i in channels) {
            var channel = channels[i];
            if (channel.id == 'qhpay' || channel.id == 'qihoo') {	// 过滤掉不支持的支付通道：暂不支持360相关支付
                continue;
            }
            pays[channel.id] = channel;
            console.log('channelid' + JSON.stringify(channel));
            // checkServices(channel);
        }
    }, function (e) {
        //outLine('获取支付通道失败：'+e.message);
		console.log('获取支付通道失败：'+e.message)
    });
    w = plus.nativeUI.showWaiting();
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function () {
        switch (xhr.readyState) {
            case 4:
                w.close(); w = null;
                if (xhr.status == 200) {
                    console.log(xhr.responseText)
                    //				outLine('----- 请求订单成功 -----');
                    var order = xhr.responseText;
                    console.log('支付请求：' + JSON.stringify(pays[id]))
                    // 判断code为 -1 返回字段不支付
                    if (order.indexOf('图文问诊不能重复购买') > -1 && JSON.parse(order).code == 1) {
                        plus.nativeUI.alert(JSON.parse(order).msg, null);
                    } else {
                        plus.payment.request(pays[id], order, function (result) {
                            console.log("支付返回："+JSON.stringify(result));
                            mui.alert('支付成功', '恭喜', function () {
                                callBack(true);
                            })
                        }, function (e) {
                            //					outLine('----- 支付失败 -----');
                        });
                    }
                } else {
                    plus.nativeUI.alert('获取订单信息失败！', null, '提示');
                }
                break;
            default:
                break;
        }
    }
    xhr.open('GET', url);
    xhr.send();
}


// iap支付  ios
tool.iapIOs = function (productNo, callBack) {
    var iapChannel;
    var IAPOrders = [];
    IAPOrders.push(productNo);
    // 获取支付通道  
    plus.payment.getChannels(function (channels) {
        plus.nativeUI.showWaiting();
        for (var i in channels) {
            if (channels[i].id == 'appleiap') {
                iapChannel = channels[i];
                // 请求商品低调男信息
                iapChannel.requestOrder(IAPOrders, function (event) {
                    plus.nativeUI.closeWaiting();
                    for (var index in event) {
                        var OrderItem = event[index];
                        // 判断当前是那个订单价格并去支付
                        if (true) {
                            // 发送支付请求
                            plus.payment.request(iapChannel, {
                                "productid": OrderItem.productid,
                                "username": "appusername",
                                "quantity": 1
                            }, function (result) {
                                callBack(result);
                                console.log('成功回调', JSON.stringify(result));
                            }, function (e) {
                                console.log(JSON.stringify(e));
                            });
                        }
                    }
                }, function (errormsg) {
                    plus.nativeUI.closeWaiting();
                    mui.toast('暂无iap商品信息');
                    console.log("获取支付通道失败：" + errormsg.message)
                });
            }
        }
    }, function (e) {
        console.log("获取支付通道失败：" + e.message);
    });
}

// 判断手机安装的地图软件com.baidu.BaiduMap
tool.chooseMapApp = function (pageName, callBack) {
    switch (plus.os.name) {
        case "Android":
            try {
                var packageName = pageName;//百度地图的包名
                var main = plus.android.runtimeMainActivity();
                var packageManager = main.getPackageManager();
                var PackageManager = plus.android.importClass(packageManager);
                var packageInfo = packageManager.getPackageInfo(packageName, PackageManager.GET_ACTIVITIES);
                if (packageInfo) {
                    callBack(true);
                    //已安装
                } else {
                    callBack(false);
                    //未安装
                }
            } catch (e) {
                callBack(false);
                //未安装
            }
            break;
        case "iOS":
            if (pageName == 'com.baidu.BaiduMap') {
                pageName = 'baidumap://';
            } else if (pageName == 'com.autonavi.minimap') {
                pageName = 'iosamap://';
            } else if (pageName == 'com.tencent.map') {
                pageName = 'qqmap://map/';
            }
            var UIApplication = plus.ios.importClass("UIApplication");
            var NSURL = plus.ios.importClass("NSURL");
            var app = UIApplication.sharedApplication();
            var bdScheme = NSURL.URLWithString(pageName);
            var install = app.canOpenURL(bdScheme);
            if (install) {
                callBack(true);
                console.log('ios安装了' + pageName)
                //ios已安装
            } else {
                callBack(false);
                //未安装
                console.log('ios未安装了' + pageName + bdScheme)
            }
            plus.ios.deleteObject(bdScheme);
            plus.ios.deleteObject(app);
            break;
        default:
            break;
    }
}
// 调用百度地图1 高德2 腾讯3
tool.baiduMap = function (index, address, point) {
    var url = '';
    console.log('开始打开地图');
    switch (index) {
        case 1:
            plus.os.name == 'Android' ? url = "baidumap://map/geocoder?" + "src=andr.baidu.openAPIdemo" + "&address=" + address : url = "baidumap://map/geocoder?address=" + address + '&src=ios.baidu.openAPIdemo';
            url = encodeURI(url);
            plus.runtime.openURL(url, function (e) { });
            break;
        case 2:
            url = 'http://uri.amap.com/marker?position=' + point.lng + ',' + point.lat + '&name=' + address + '&src=mypage&coordinate=gaode&callnative=1'
            url = encodeURI(url);
            var ifr = document.createElement("iframe");
            ifr.setAttribute('src', url);
            ifr.setAttribute('style', 'display:none');
            document.body.appendChild(ifr);
            break;
        case 3:
            // url = 'qqmap://map/search?keyword=' + address + '&center=' + point.lng + ',' + point.lat + '&radius=10000&referer=OB4BZ-D4W3U-B7VVO-4PJWW-6TKDJ-WPB77';
            url = 'qqmap://map/geocoder?coord=' + point.lat + ',' + point.lng + '&referer=OB4BZ-D4W3U-B7VVO-4PJWW-6TKDJ-WPB77';
            url = encodeURI(url);
            console.log(url)
            plus.runtime.openURL(url, function (e) {
                console.log(e)
            });
            break;
        default:
            break;
    }
    // 异常关闭加载框
    plus.nativeUI.closeWaiting();
    return encodeURI(url);
};
// 判断时间间隔
/**判断时间间隔多少小时*/
tool.judgeTimeDiffer = function (time) {
    // 当前时间
    var currentTimeDate = new Date();
    var currentTime = currentTimeDate.getTime();
    // 帖子创建时间
    var startTimeDate = new Date(time);
    var startTime = startTimeDate.getTime();
    var judgeTime = {
        year: currentTimeDate.getFullYear() - startTimeDate.getFullYear(),
        mon: (currentTimeDate.getMonth() + 1) + ((currentTimeDate.getFullYear() - startTimeDate.getFullYear()) * 12) - (startTimeDate.getMonth() + 1),
        day: parseInt((currentTime - startTime) / 86400000),
        hour: parseInt((currentTime - startTime) / 3600000),
        min: parseInt((currentTime - startTime) / 60000),
        second: parseInt((currentTime - startTime) / 1000)
    };
    if (judgeTime.year >= 1) {
        return judgeTime.year + '年前';
    } else if (judgeTime.mon >= 1) {
        return judgeTime.mon + '个月前';
    } else if (judgeTime.day >= 1) {
        return judgeTime.day + '天前';
    } else if (judgeTime.hour >= 1) {
        return judgeTime.hour + '小时前';
    } else if (judgeTime.min >= 1) {
        return judgeTime.min + '分钟前';
    } else if (judgeTime.second >= 1) {
        return judgeTime.second + '秒前';
    }
}

//压缩图片
function convertImgToBase64(url, callback, outputFormat) {
    var canvas = document.createElement('CANVAS'),
        ctx = canvas.getContext('2d'),
        img = new Image;
    img.crossOrigin = 'Anonymous';
    img.onload = function () {
        // canvas.height = img.height;
        // canvas.width = img.width;
        var rate = img.height / img.width;
        canvas.width = 1080;
        canvas.height = canvas.width * rate;
        ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
        var dataURL = canvas.toDataURL(outputFormat || 'image/jpeg', 0.5);
        callback.call(this, dataURL);
        canvas = null;
    };
    img.src = url;
}